problem with "matrix" argument in functions

21 May 2013 17:24 - Anna Maria Bigatti

Status: Closed Start date: 21 May 2013

Priority: Immediate Due date:  

Assignee: John Abbott % Done: 100%

Category: Safety Estimated time: 0.00 hour

Target version: CoCoALib-0.99535 Sep14 Spent time: 2.35 hours

Description

If a function has argument "matrix M" (instead of MatrixView or ConstMatrixView) it is passed as a "pointer", i.e. if M is modified

inside the function, the outside matrix is modified.

I think there is no cure for this: they are pointers.

Should we write it in the documentation?

I'll post an explicit example when I have time to try

Related issues:

Related to CoCoALib - Design #592: Review design of ConstMatrixView Closed 17 Jul 2014

History

#1 - 29 Oct 2013 15:20 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99534 Seoul14 to CoCoALib-0.99532

#2 - 01 Apr 2014 17:27 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99532 to CoCoALib-0.99533 Easter14

#3 - 07 Apr 2014 18:22 - John Abbott

- Target version changed from CoCoALib-0.99533 Easter14 to CoCoALib-0.99534 Seoul14

#4 - 14 Jul 2014 15:15 - John Abbott

- Target version changed from CoCoALib-0.99534 Seoul14 to CoCoALib-1.0

#5 - 16 Aug 2014 13:42 - John Abbott

- Status changed from New to In Progress

- Assignee set to John Abbott

- Priority changed from Normal to Immediate

I've just been burned by this bug.  It definitely falls into the category nasty surprise.  I'll try to fix ASAP.

#6 - 16 Aug 2014 13:46 - John Abbott

Here is an explicit example:

RingElem bareiss(matrix M)

{

  const int n = NumRows(M);

  CoCoA_ASSERT(NumCols(M) == n);

  ring R = RingOf(M);

  RingElem d = one(R);

  for (int k=0; k < n; ++k)

  {

    for (int i=k+1; i < n; ++i)

      for (int j=k+1; j < n; ++j)
      {

        SetEntry(M,i,j,(M(i,j)*M(k,k)-M(i,k)*M(k,j))/d );

      }

    d = M(k,k);

  }

  return d;

}

 

This fn should not trash M but it does currently.

#7 - 16 Aug 2014 14:55 - John Abbott

- % Done changed from 0 to 70

I have made a few changes.  All CoCoALib tests pass, and the example I gave above produces the desired behaviour.  Checking in.

#8 - 16 Aug 2014 15:22 - John Abbott

CVS is working terribly: sometimes fails, otherwise VERY SLOW.  No idea why :-(

I hope to succeed with checking in -- the technicians are away on holiday...

#9 - 16 Aug 2014 16:01 - John Abbott

- Status changed from In Progress to Closed

- % Done changed from 70 to 100

Since all tests seems to work correctly, I'm closing this issue.

There are some design questions still to consider, but that can be done as part of #592.

#10 - 16 Aug 2014 16:02 - John Abbott

- Target version changed from CoCoALib-1.0 to CoCoALib-0.99536 June 2015

#11 - 11 Sep 2014 16:41 - John Abbott

- Target version changed from CoCoALib-0.99536 June 2015 to CoCoALib-0.99535 Sep14
